IMPLEMENTATION MODULE NLGEM;

(* By: Harrie F.A. de Leeuw   *)
(* Part of 'NiceList' program *)


FROM SYSTEM             IMPORT ADDRESS,
                               ADR;
FROM String             IMPORT Assign,
                               Length;

FROM ObjTypes           IMPORT Tree,
                               TedInfo;

(*********************) IMPORT GEMVDIbase;
FROM VDIControls        IMPORT OpenVirtualWorkstation,
                               CloseVirtualWorkstation;

(*********************) IMPORT GEMAESbase;
FROM AESGraphics        IMPORT GrafHandle,
                               GrafMouse;
FROM AESApplications    IMPORT ApplInitialise,
                               ApplExit;
FROM AESResources       IMPORT ResourceLoad,
                               ResourceGetAddr,
                               ResourceFree;
FROM AESForms           IMPORT FormCenter,
                               FormDialogue,
                               FormDo;
FROM AESObjects         IMPORT ObjectDraw,
                               ObjectChange;



CONST                   (* From resource construction set *)
      MENU = 0;  (* TREE *)
      INFO1 = 1;  (* TREE *)
      INFO2 = 2;  (* TREE *)
      INFO3 = 3;  (* TREE *)
      INFO4 = 4;  (* TREE *)
      INFO5 = 5;  (* TREE *)
      FILENAME = 5;  (* OBJECT in TREE #0 *)
      DIRECTOR = 11;  (* OBJECT in TREE #0 *)
      DRIVEA = 14;  (* OBJECT in TREE #0 *)
      DRIVEB = 15;  (* OBJECT in TREE #0 *)
      DRIVEC = 16;  (* OBJECT in TREE #0 *)
      DRIVED = 17;  (* OBJECT in TREE #0 *)
      INFO = 23;  (* OBJECT in TREE #0 *)
      START = 24;  (* OBJECT in TREE #0 *)
      MORE1 = 23;  (* OBJECT in TREE #1 *)
      CANCEL1 = 22;  (* OBJECT in TREE #1 *)
      MORE2 = 20;  (* OBJECT in TREE #2 *)
      CANCEL2 = 19;  (* OBJECT in TREE #2 *)
      MORE3 = 29;  (* OBJECT in TREE #3 *)
      CANCEL3 = 28;  (* OBJECT in TREE #3 *)
      MORE4 = 22;  (* OBJECT in TREE #4 *)
      CANCEL4 = 21;  (* OBJECT in TREE #4 *)
      QUIT = 22;  (* OBJECT in TREE #0 *)
      OK5 = 3;  (* OBJECT in TREE #5 *)
      DRIVEE = 18;  (* OBJECT in TREE #0 *)
      DRIVEF = 19;  (* OBJECT in TREE #0 *)


TYPE Text=              ARRAY[0..40] OF CHAR;

VAR MenuTreeAddr,
    Info1TreeAddr,
    Info2TreeAddr,
    Info3TreeAddr,
    Info4TreeAddr,
    Info5TreeAddr:      POINTER TO Tree;
    TedInfoAddr:        POINTER TO TedInfo;
    TextAddr:           POINTER TO Text;
    X,Y,W,H:            INTEGER;
    DiaOpen:            BOOLEAN;
    DirectoryStr,
    FileNameStr:        Text;

    
PROCEDURE InitProgram;
VAR Dum,
    ApId,
    PhysHandle:         INTEGER;
    WorkIn:             GEMVDIbase.VDIWorkInType;
    WorkOut:            GEMVDIbase.VDIWorkOutType;
    DumAddr:            ADDRESS;
BEGIN
  ApId:=ApplInitialise();
  PhysHandle:=GrafHandle(CharWidth,CharHeight,Dum,Dum);
  FOR Dum:=1 TO 8 DO
    WorkIn[Dum]:=1
  END;
  WorkIn[9]:=0;
  WorkIn[10]:=2;
  WorkstationHandle:=PhysHandle;
  OpenVirtualWorkstation(WorkIn,WorkstationHandle,WorkOut);
  ResourceLoad('NICELIST.RSC');
  ResourceGetAddr(GEMAESbase.RTree,MENU,MenuTreeAddr);
  ResourceGetAddr(GEMAESbase.RTree,INFO1,Info1TreeAddr);
  ResourceGetAddr(GEMAESbase.RTree,INFO2,Info2TreeAddr);
  ResourceGetAddr(GEMAESbase.RTree,INFO3,Info3TreeAddr);
  ResourceGetAddr(GEMAESbase.RTree,INFO4,Info4TreeAddr);
  ResourceGetAddr(GEMAESbase.RTree,INFO5,Info5TreeAddr);
  ObjectChange(MenuTreeAddr,DRIVEA,0,0,0,639,399,GEMAESbase.Selected,0);
(* In the MENU tree there are 2 tedinfo's (DIRECTOR and FILENAME).
   In the resource-file the room reservated for TePText of these
   tedinfo's is too less.  (Changing the length with the help of the
   Resource Construction Set results in bombs!?  RCS has bugs!?)
   The following instructions make TePText of DIRECTOR and FILENAME
   point to the strings DirectoryStr and FileNameStr.
   Also the strings are initialised.                                 *)
  TedInfoAddr:=ADDRESS(MenuTreeAddr^[DIRECTOR].ObSpec);
  DirectoryStr[0]:='\';
  DirectoryStr[1]:=0C;
  TedInfoAddr^.TePText:=ADR(DirectoryStr);
  TedInfoAddr^.TeTxtlen:=41;
  TedInfoAddr:=ADDRESS(MenuTreeAddr^[FILENAME].ObSpec);
  FileNameStr[0]:=0C;
  TedInfoAddr^.TePText:=ADR(FileNameStr);
  TedInfoAddr^.TeTxtlen:=41;
  GrafMouse(GEMAESbase.Arrow,DumAddr)
END InitProgram;



PROCEDURE ShowInfo;
VAR Touched: INTEGER;
BEGIN
  FormCenter(Info1TreeAddr,X,Y,W,H);
  ObjectDraw(Info1TreeAddr,0,2,X,Y,W,H);
  Touched:=FormDo(Info1TreeAddr,0);
  ObjectChange(Info1TreeAddr,Touched,0,X,Y,W,H,GEMAESbase.Normal,0);
  IF Touched=MORE1 THEN
    FormCenter(Info2TreeAddr,X,Y,W,H);
    ObjectDraw(Info2TreeAddr,0,2,X,Y,W,H);
    Touched:=FormDo(Info2TreeAddr,0);
    ObjectChange(Info2TreeAddr,Touched,0,X,Y,W,H,GEMAESbase.Normal,0);
    IF Touched=MORE2 THEN
      FormCenter(Info3TreeAddr,X,Y,W,H);
      ObjectDraw(Info3TreeAddr,0,2,X,Y,W,H);
      Touched:=FormDo(Info3TreeAddr,0);
      ObjectChange(Info3TreeAddr,Touched,0,X,Y,W,H,GEMAESbase.Normal,0);
      IF Touched=MORE3 THEN
        FormCenter(Info4TreeAddr,X,Y,W,H);
        ObjectDraw(Info4TreeAddr,0,2,X,Y,W,H);
        Touched:=FormDo(Info4TreeAddr,0);
        ObjectChange(Info4TreeAddr,Touched,0,X,Y,W,H,GEMAESbase.Normal,0);
        IF Touched=MORE4 THEN
          FormCenter(Info5TreeAddr,X,Y,W,H);
          ObjectDraw(Info5TreeAddr,0,2,X,Y,W,H);
          Touched:=FormDo(Info5TreeAddr,0);
          ObjectChange(Info5TreeAddr,Touched,0,X,Y,W,H,GEMAESbase.Normal,0)
        END
      END
    END
  END
END ShowInfo;



PROCEDURE MenuForm;
VAR Touched,
    ObjectState,
    Len:            INTEGER;
    DoneOk:         BOOLEAN;

  PROCEDURE CloseMenu;
  BEGIN
    FormDialogue(GEMAESbase.FormShrink,X+(W DIV 2),Y+(H DIV 2),1,1,X,Y,W,H);
    FormDialogue(GEMAESbase.FormFinish,X+(W DIV 2),Y+(H DIV 2),1,1,X,Y,W,H);
    ObjectChange(MenuTreeAddr,QUIT,0,X,Y,W,H,GEMAESbase.Normal,0);
    DiaOpen:=FALSE
  END CloseMenu;

BEGIN (* MenuForm *)
  IF ~DiaOpen THEN
    FormCenter(MenuTreeAddr,X,Y,W,H);
    FormDialogue(GEMAESbase.FormStart,X+(W DIV 2),Y+(H DIV 2),1,1,X,Y,W,H);
    DiaOpen:=TRUE
  END;
  FormDialogue(GEMAESbase.FormGrow,X+(W DIV 2),Y+(H DIV 2),1,1,X,Y,W,H);
  ObjectDraw(MenuTreeAddr,0,2,X,Y,W,H);
  ObjectChange(MenuTreeAddr,START,0,X,Y,W,H,GEMAESbase.Normal,1);
  ObjectChange(MenuTreeAddr,INFO,0,X,Y,W,H,GEMAESbase.Normal,1);
  Touched:=FormDo(MenuTreeAddr,FILENAME);
  IF Touched=START THEN
    TedInfoAddr:=ADDRESS(MenuTreeAddr^[FILENAME].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    Assign(FileName,TextAddr^);
    TedInfoAddr:=ADDRESS(MenuTreeAddr^[DIRECTOR].ObSpec);
    TextAddr:=TedInfoAddr^.TePText;
    IF TextAddr^[0]=0C THEN
      Directory[0]:='\';
      Directory[1]:=0C
    ELSE
      Assign(Directory,TextAddr^);
      Len:=Length(Directory);
      IF Directory[Len-1]#'\' THEN
        Directory[Len]:='\';
        Directory[Len+1]:=0C
      END
    END;
    ObjectState:=MenuTreeAddr^[DRIVEA].ObState;
    IF ((ObjectState DIV GEMAESbase.Selected) MOD 2)=1 THEN
      Drive:=0
    ELSE
      ObjectState:=MenuTreeAddr^[DRIVEB].ObState;
      IF ((ObjectState DIV GEMAESbase.Selected) MOD 2)=1 THEN
        Drive:=1
      ELSE
        ObjectState:=MenuTreeAddr^[DRIVEC].ObState;
        IF ((ObjectState DIV GEMAESbase.Selected) MOD 2)=1 THEN
          Drive:=2
        ELSE
          ObjectState:=MenuTreeAddr^[DRIVED].ObState;
          IF ((ObjectState DIV GEMAESbase.Selected) MOD 2)=1 THEN
            Drive:=3
          ELSE
            ObjectState:=MenuTreeAddr^[DRIVEE].ObState;
            IF ((ObjectState DIV GEMAESbase.Selected) MOD 2)=1 THEN
              Drive:=4
            ELSE
              Drive:=5
            END
          END
        END
      END
    END;
    CloseMenu;
    SelectedButton:=Start
  ELSE
    IF Touched=INFO THEN
      ShowInfo;
      SelectedButton:=Info
    ELSE
      CloseMenu;
      SelectedButton:=Quit
    END
  END
END MenuForm;



PROCEDURE EndProgram;
BEGIN
  ResourceFree();
  CloseVirtualWorkstation(WorkstationHandle);
  ApplExit()
END EndProgram;



BEGIN
  DiaOpen:=FALSE
END NLGEM.
