IMPLEMENTATION MODULE NLOutWindow;

(* By: Harrie F.A. de Leeuw   *)
(* Part of 'NiceList' program *)


FROM SYSTEM             IMPORT ADR,
                               ADDRESS,
                               CODE,
                               REGISTER;
FROM String             IMPORT Strings,
                               Length,
                               Assign;

FROM NLGEM              IMPORT WorkstationHandle,
                               CharHeight,
                               CharWidth;

(*********************) IMPORT GEMAESbase;
FROM AESWindows         IMPORT WindowGet,
                               WindowCalc,
                               WindowCreate,
                               WindowOpen,
                               WindowSet,
                               WindowClose,
                               WindowDelete;

(*********************) IMPORT GEMVDIbase;
FROM VDIInputs          IMPORT HideCursor,
                               ShowCursor;
FROM VDIOutputs         IMPORT FillRectangle,
                               GraphicText;
FROM VDIControls        IMPORT SetClipping;
FROM VDIRasters         IMPORT CopyRasterOpaque;



VAR Xw,Yw,Ww,Hw,
    WindowHandle,
    TextX,TextY:           INTEGER;
    BigPxy:                GEMVDIbase.BigPxyArrayType;
    MFDBscreen:            ARRAY[1..10] OF INTEGER;
    Header:                Strings;


PROCEDURE OpenOutWindow;
VAR Xd,Yd,Wd,Hd,
    Xt,Yt,Wt,Ht: INTEGER;
    PxyArray:    GEMVDIbase.PxyArrayType;
BEGIN
  WindowGet(0,GEMAESbase.WorkXYWH,Xd,Yd,Wd,Hd);
  WindowCalc(1,GEMAESbase.Name,Xd,Yd,Wd,Hd,Xw,Yw,Ww,Hw);
  WindowCalc(0,GEMAESbase.Name,Xw+(CharWidth DIV 2),
                               Yw+(CharHeight DIV 2),
                               ((Ww DIV CharWidth)-2)*CharWidth,
                               ((Hw DIV CharHeight)-1)*CharHeight,
                               Xt,Yt,Wt,Ht);
  WindowCalc(1,GEMAESbase.Name,Xt,Yt,Wt,Ht,Xw,Yw,Ww,Hw);
  WindowHandle:=WindowCreate(GEMAESbase.Name,Xt,Yt,Wt,Ht);
  WindowSet(WindowHandle,GEMAESbase.WindowName,
            INTEGER(LONGCARD(ADR(Header)) DIV 10000H),
            INTEGER(LONGCARD(ADR(Header)) MOD 10000H),0,0);
  HideCursor(WorkstationHandle);
  WindowOpen(WindowHandle,Xt,Yt,Wt,Ht);
  PxyArray[0]:=Xw;
  PxyArray[1]:=Yw;
  PxyArray[2]:=Xw+Ww-1;
  PxyArray[3]:=Yw+Hw-1;
  SetClipping(WorkstationHandle,1,PxyArray);
  FillRectangle(WorkstationHandle,PxyArray);
  ShowCursor(WorkstationHandle,1);
  BigPxy[0]:=Xw;
  BigPxy[1]:=Yw+CharHeight;
  BigPxy[2]:=Xw+Ww-1;
  BigPxy[3]:=Yw+Hw-1;
  BigPxy[4]:=Xw;
  BigPxy[5]:=Yw;
  BigPxy[6]:=Xw+Ww-1;
  BigPxy[7]:=Yw+Hw-1-CharHeight;
  TextX:=Xw+CharWidth;
  TextY:=Yw+Hw-3
END OpenOutWindow;



PROCEDURE WriteOutWindow(S:Strings);
BEGIN
  HideCursor(WorkstationHandle);
  CopyRasterOpaque(WorkstationHandle,3,BigPxy,
                        ADR(MFDBscreen),ADR(MFDBscreen));
  GraphicText(WorkstationHandle,TextX,TextY,S);
  GraphicText(WorkstationHandle,TextX+(INTEGER(Length(S))*CharWidth),TextY,
'                                                                        ');
  ShowCursor(WorkstationHandle,1)
END WriteOutWindow;



PROCEDURE CloseOutWindow;
BEGIN
  WindowClose(WindowHandle);
  WindowDelete(WindowHandle)
END CloseOutWindow;



PROCEDURE ScreenAddress():ADDRESS;
BEGIN
  CODE(7000H);          (* MOVEQ.L #0,D0    *)
  CODE(3F3CH,2);        (* MOVE.W  #2,-(SP) *)
  CODE(4E4EH);          (* TRAP    #14      *)
  RETURN REGISTER(0)
END ScreenAddress;



BEGIN
  Assign(Header,' Output ');
  MFDBscreen[1]:=INTEGER(LONGCARD(ScreenAddress()) DIV 10000H);
  MFDBscreen[2]:=INTEGER(LONGCARD(ScreenAddress()) MOD 10000H);
  MFDBscreen[3]:=640;
  MFDBscreen[4]:=400;
  MFDBscreen[5]:=40;
  MFDBscreen[6]:=0;
  MFDBscreen[7]:=1
END NLOutWindow.
