IMPLEMENTATION MODULE NLSetUp;

(* By: Harrie F.A. de Leeuw   *)
(* Part of 'NiceList' program *)


FROM TextIO        IMPORT REadLn, REadString;
FROM String        IMPORT Strings, Compare, CompareResults;
FROM Streams       IMPORT OpenStream, CloseStream, EOS, StreamKinds, Stream;
FROM M2Conversions IMPORT ConvertToCardinal;
FROM AESForms      IMPORT FormAlert;


VAR SetupFile:          Stream;
    InPoint,
    Dum:                CARDINAL;
    StreamState:        INTEGER;
    Help,
    InLine,
    Command:            Strings;




PROCEDURE ReadNumbers(VAR S:Strings);
VAR Num: Strings;
    NumPoint,SPoint: INTEGER;
    Code: CARDINAL;
    Ok: BOOLEAN;
BEGIN
  WHILE ((InLine[InPoint]=' ') & (InLine[InPoint]#0C)) DO
    InPoint:=InPoint+1
  END;
  IF InLine[InPoint-1]=0C THEN
    Dum:=FormAlert(1,'[3][ |Error in NLSETUP.PRT!][Abort]');
    HALT
  END;
  SPoint:=1;
  REPEAT
    NumPoint:=0;
    WHILE ((InLine[InPoint]#' ')
         & (InLine[InPoint]#',')
         & (InLine[InPoint]#0C)) DO
      Num[NumPoint]:=InLine[InPoint];
      NumPoint:=NumPoint+1;
      InPoint:=InPoint+1
    END;
    Num[NumPoint]:=0C;
    ConvertToCardinal(Num,Ok,Code);
    IF ~Ok THEN
      Dum:=FormAlert(1,'[3][ |Error in NLSETUP.PRT!][Abort]');
      HALT
    END;
    S[SPoint]:=CHR(Code);
    SPoint:=SPoint+1;
    InPoint:=InPoint+1
  UNTIL (InLine[InPoint-1]#',');
  S[0]:=CHR(SPoint-1)
END ReadNumbers;


BEGIN
  SetDouble[0]:=0C;
  SetEnlarge[0]:=0C;
  SetEmphasize[0]:=0C;
  SetCondense[0]:=0C;
  SetUnderline[0]:=0C;
  SetSubscript[0]:=0C;
  SetSuperscript[0]:=0C;
  ResetDouble[0]:=0C;
  ResetEnlarge[0]:=0C;
  ResetEmphasize[0]:=0C;
  ResetCondense[0]:=0C;
  ResetUnderline[0]:=0C;
  ResetSubscript[0]:=0C;
  ResetSuperscript[0]:=0C;
  SetSpacing[0]:=0C;
  DotsPerLine:=12;
  NrOfLinesPerPage:=60;
  OpenStream(SetupFile,'NLSETUP.PRT',READ,StreamState);
  IF StreamState#0 THEN
    Dum:=FormAlert(1,
    '[3][ |NLSETUP.PRT not found!| |Nice-List needs this file!][Abort]');
    HALT
  END;
  REPEAT
    REadString(SetupFile,InLine);
    REadLn(SetupFile);
    IF InLine[0]#'/' THEN
      InPoint:=0;
      WHILE ((InLine[InPoint]#' ') & (InLine[InPoint]#0C)) DO
        Command[InPoint]:=InLine[InPoint];
        InPoint:=InPoint+1
      END;
      IF InLine[InPoint-1]=0C THEN
        Dum:=FormAlert(1,'[3][ |Error in NLSETUP.PRT!][Abort]');
        HALT
      END;
      Command[InPoint]:=0C;
      IF Compare(Command,'SetDouble')=Equal THEN
        ReadNumbers(SetDouble)
      ELSIF Compare(Command,'SetEnlarge')=Equal THEN
        ReadNumbers(SetEnlarge)
      ELSIF Compare(Command,'SetEmphasize')=Equal THEN
        ReadNumbers(SetEmphasize)
      ELSIF Compare(Command,'SetCondense')=Equal THEN
        ReadNumbers(SetCondense)
      ELSIF Compare(Command,'SetUnderline')=Equal THEN
        ReadNumbers(SetUnderline)
      ELSIF Compare(Command,'SetSubscript')=Equal THEN
        ReadNumbers(SetSubscript)
      ELSIF Compare(Command,'SetSuperscript')=Equal THEN
        ReadNumbers(SetSuperscript)
      ELSIF Compare(Command,'ResetDouble')=Equal THEN
        ReadNumbers(ResetDouble)
      ELSIF Compare(Command,'ResetEnlarge')=Equal THEN
        ReadNumbers(ResetEnlarge)
      ELSIF Compare(Command,'ResetEmphasize')=Equal THEN
        ReadNumbers(ResetEmphasize)
      ELSIF Compare(Command,'ResetCondense')=Equal THEN
        ReadNumbers(ResetCondense)
      ELSIF Compare(Command,'ResetUnderline')=Equal THEN
        ReadNumbers(ResetUnderline)
      ELSIF Compare(Command,'ResetSubscript')=Equal THEN
        ReadNumbers(ResetSubscript)
      ELSIF Compare(Command,'ResetSuperscript')=Equal THEN
        ReadNumbers(ResetSuperscript)
      ELSIF Compare(Command,'SetSpacing')=Equal THEN
        ReadNumbers(SetSpacing)
      ELSIF Compare(Command,'DotsPerLine')=Equal THEN
        ReadNumbers(Help);
        DotsPerLine:=ORD(Help[1])
      ELSIF Compare(Command,'NrOfLinesPerPage')=Equal THEN
        ReadNumbers(Help);
        NrOfLinesPerPage:=ORD(Help[1])
      ELSE
        Dum:=FormAlert(1,'[3][ |Error in NLSETUP.PRT!][Abort]')
      END
    END
  UNTIL EOS(SetupFile);
  FormLength:=DotsPerLine*NrOfLinesPerPage;
  CloseStream(SetupFile,StreamState)
END NLSetUp.
